
#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Red
#property indicator_color4 DeepSkyBlue
#property indicator_color5 Red
#property indicator_color6 DeepSkyBlue


//---- input parameters
extern int       iHalfPeriod=14;
extern bool      ShowTrendLines=false;
extern bool      ShowSupResLines=false;
extern bool      ShowFiboLines=false;
extern bool      ShowFiboExpansion=false;
extern bool      ShowFiboFan=false;
extern int       FiboFanType=1;
extern bool      ShowFiboArc=false;
extern int       FiboArcType=1;
extern bool      ShowFiboTime=false;
extern int       FiboTimeType=1;
extern int       Count=5;  
extern int       Shift=0;  

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

 
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,158);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,158);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0); 
   
   
   
   SetIndexStyle(4,DRAW_ARROW,0,2);
   SetIndexArrow(4,241);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);   
   
   SetIndexStyle(5,DRAW_ARROW,0,2);
   SetIndexArrow(5,242);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);    
   
   
   
    
     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit=Bars-IndicatorCounted();
   static double luv,llv;
      for(int i=limit;i>=0;i--){
         ExtMapBuffer1[i]=0;
         ExtMapBuffer2[i]=0; 
         ExtMapBuffer3[i]=0;
         ExtMapBuffer4[i]=0;          
                 
         int hb=Highest(NULL,0,MODE_HIGH,iHalfPeriod*2+1,i+1);
         int lb=Lowest(NULL,0,MODE_LOW,iHalfPeriod*2+1,i+1); 
         
            if(hb==i+iHalfPeriod+2){
               ExtMapBuffer1[hb]=High[hb];
               //lf=1;
               luv=High[hb];
            }
            if(lb==i+iHalfPeriod+2){
               ExtMapBuffer2[lb]=Low[lb];
               //lf=2;
               llv=Low[lb];
            }            
        ExtMapBuffer3[i]=luv;
        ExtMapBuffer4[i]=llv;  
         if(ExtMapBuffer3[i]!=0 && ExtMapBuffer3[i+1]==ExtMapBuffer3[i]){
            if(High[i]>ExtMapBuffer3[i] && High[i+1]<=ExtMapBuffer3[i+1]){
               ExtMapBuffer5[i]=Low[i]-Point*5;
            }
         }   
         if(ExtMapBuffer4[i]!=0 && ExtMapBuffer4[i+1]==ExtMapBuffer4[i]){
            if(Low[i]<ExtMapBuffer4[i] && Low[i+1]>=ExtMapBuffer4[i+1]){
               ExtMapBuffer6[i]=High[i]+Point*5;
            }
         }             
            
            
      }

   return(0);
  }
//+------------------------------------------------------------------+